"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = createUtilityPlugin;

var _transformThemeValue = _interopRequireDefault(require("./transformThemeValue"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function createUtilityPlugin(themeKey, utilityVariations = [[themeKey, [themeKey]]], {
  filterDefault = false,
  type = 'any'
} = {}) {
  let transformValue = (0, _transformThemeValue.default)(themeKey);
  return function ({
    matchUtilities,
    theme
  }) {
    for (let utilityVariation of utilityVariations) {
      var _theme;

      let group = Array.isArray(utilityVariation[0]) ? utilityVariation : [utilityVariation];
      matchUtilities(group.reduce((obj, [classPrefix, properties]) => {
        return Object.assign(obj, {
          [classPrefix]: value => {
            return properties.reduce((obj, name) => {
              if (Array.isArray(name)) {
                return Object.assign(obj, {
                  [name[0]]: name[1]
                });
              }

              return Object.assign(obj, {
                [name]: transformValue(value)
              });
            }, {});
          }
        });
      }, {}), {
        values: filterDefault ? Object.fromEntries(Object.entries((_theme = theme(themeKey)) !== null && _theme !== void 0 ? _theme : {}).filter(([modifier]) => modifier !== 'DEFAULT')) : theme(themeKey),
        type
      });
    }
  };
}